// Generated by the protocol buffer compiler.  DO NOT EDIT!
// NO CHECKED-IN PROTOBUF GENCODE
// source: src/main/protobuf/file_invalidation_data.proto
// Protobuf Java Version: 4.29.0-rc1

package com.google.devtools.build.lib.skyframe.serialization.proto;

/**
 * <pre>
 * This message contains sufficient information to invalidate Bazel file
 * dependencies against repository diffs.
 *
 * The goal is for this data to represent
 * `com.google.devtools.build.lib.vfs.FileStateKey.argument` values. However,
 * these values are represented within a structure defined by the
 * `com.google.devtools.build.lib.skyframe.FileFunction`, meaning that whenever
 * a `FileStateKey.argument` is encountered, it implies that its parent
 * directory will be present. Therefore, there's going to be significant
 * redundancy in the path information.
 *
 * This redundancy can be exploited for compactness, resulting in this implicit
 * representation.
 *
 * This value is always used in the context of a key-value store (e.g.
 * Memcached), where the key is defined as follows. Let E be some
 * Memcached-friendly encoding function, (e.g. Base64) and `:` be a delimiter in
 * the following (`:` does not occur in Base64, making it a good delimiter). Let
 * MTSV be the maximum transitive source version, a version number that is the
 * maximum version over all the transitive source files affecting an entry. In
 * the case of a file, this includes all source versions of all parent
 * directories and any symlinks needed to resolve it. The MTSV is a canonical
 * version for the file.
 *
 * KEY = E(MTSV) : &lt;FileValue.Key.argument path&gt;
 *
 * Logically, the key consists of the FileValue's MTSV and unresolved path.
 * Note, in particular, the path data present in the key does not need to be
 * repeated in the value. The parent directory of this key is already the
 * `FileValue.Key.argument` path of its parent directory, so that doesn't need
 * to be repeated either. The only additional data needed to identify the
 * `FileInvalidationData` of its parent is the parent's MTSV, which is included
 * as `parent_mtsv`.
 *
 * In the common case, `FileInvalidationData` is empty and that's sufficient
 * information to derive all the paths, assuming that the parent lookups are
 * transitively performed. The `FileStateKey.argument` matches the path present
 * in the key.
 *
 * In the presence of symlinks, special logic applies to produce the resolved
 * paths. A `symlinks` entry will be present. To unpack the symlink entry, we
 * first resolve the parent path as usual. Then, we concatenate the symlink's
 * contents to the resolved parent path and syntactically normalize it
 * (interpreting things like `..`, `.` using string manipulation). This
 * establishes a new path to be recursively resolved. `Symlink` contains another
 * `parent_mtsv` for this purpose. The resulting resolved path is another
 * implicit `FileStateKey.argument` value. If this path is itself a symlink, the
 * process is repeated.
 *
 * Note that this is only suitable for persisting information about a successful
 * build so it ignores symlink cycles.
 * </pre>
 *
 * Protobuf type {@code devtools.skyframe.FileInvalidationData}
 */
public final class FileInvalidationData extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:devtools.skyframe.FileInvalidationData)
    FileInvalidationDataOrBuilder {
private static final long serialVersionUID = 0L;
  static {
    com.google.protobuf.RuntimeVersion.validateProtobufGencodeVersion(
      com.google.protobuf.RuntimeVersion.RuntimeDomain.PUBLIC,
      /* major= */ 4,
      /* minor= */ 29,
      /* patch= */ 0,
      /* suffix= */ "-rc1",
      FileInvalidationData.class.getName());
  }
  // Use FileInvalidationData.newBuilder() to construct.
  private FileInvalidationData(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FileInvalidationData() {
    overflowKey_ = "";
    symlinks_ = java.util.Collections.emptyList();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOuterClass.internal_static_devtools_skyframe_FileInvalidationData_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOuterClass.internal_static_devtools_skyframe_FileInvalidationData_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.class, com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.Builder.class);
  }

  private int bitField0_;
  public static final int OVERFLOW_KEY_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private volatile java.lang.Object overflowKey_ = "";
  /**
   * <pre>
   * The following field is populated when the key needs to be abbreviated to
   * its fingerprint due to Memcached's key length restriction. This field can
   * be used to verify that no fingerprint collision has occurred.
   * </pre>
   *
   * <code>string overflow_key = 1;</code>
   * @return Whether the overflowKey field is set.
   */
  @java.lang.Override
  public boolean hasOverflowKey() {
    return ((bitField0_ & 0x00000001) != 0);
  }
  /**
   * <pre>
   * The following field is populated when the key needs to be abbreviated to
   * its fingerprint due to Memcached's key length restriction. This field can
   * be used to verify that no fingerprint collision has occurred.
   * </pre>
   *
   * <code>string overflow_key = 1;</code>
   * @return The overflowKey.
   */
  @java.lang.Override
  public java.lang.String getOverflowKey() {
    java.lang.Object ref = overflowKey_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      overflowKey_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * The following field is populated when the key needs to be abbreviated to
   * its fingerprint due to Memcached's key length restriction. This field can
   * be used to verify that no fingerprint collision has occurred.
   * </pre>
   *
   * <code>string overflow_key = 1;</code>
   * @return The bytes for overflowKey.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getOverflowKeyBytes() {
    java.lang.Object ref = overflowKey_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      overflowKey_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int PARENT_MTSV_FIELD_NUMBER = 2;
  private long parentMtsv_ = 0L;
  /**
   * <pre>
   * The MTSV used to resolve the parent directory.
   *
   * Resolution means creating a key from this MTSV and the parent directory of
   * the key of this entry, looking up the value and interpreting it.
   *
   * Optional. Unset in the following two cases.
   * 1. When the path has no parent, i.e. contains no '/' separators
   * 2. It is a directory and has the common sentinel value, -1.
   * </pre>
   *
   * <code>int64 parent_mtsv = 2;</code>
   * @return Whether the parentMtsv field is set.
   */
  @java.lang.Override
  public boolean hasParentMtsv() {
    return ((bitField0_ & 0x00000002) != 0);
  }
  /**
   * <pre>
   * The MTSV used to resolve the parent directory.
   *
   * Resolution means creating a key from this MTSV and the parent directory of
   * the key of this entry, looking up the value and interpreting it.
   *
   * Optional. Unset in the following two cases.
   * 1. When the path has no parent, i.e. contains no '/' separators
   * 2. It is a directory and has the common sentinel value, -1.
   * </pre>
   *
   * <code>int64 parent_mtsv = 2;</code>
   * @return The parentMtsv.
   */
  @java.lang.Override
  public long getParentMtsv() {
    return parentMtsv_;
  }

  public static final int SYMLINKS_FIELD_NUMBER = 3;
  @SuppressWarnings("serial")
  private java.util.List<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink> symlinks_;
  /**
   * <pre>
   * This field is repeated, with one entry for each symbolic link encountered
   * while resolving the path.
   * </pre>
   *
   * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
   */
  @java.lang.Override
  public java.util.List<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink> getSymlinksList() {
    return symlinks_;
  }
  /**
   * <pre>
   * This field is repeated, with one entry for each symbolic link encountered
   * while resolving the path.
   * </pre>
   *
   * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder> 
      getSymlinksOrBuilderList() {
    return symlinks_;
  }
  /**
   * <pre>
   * This field is repeated, with one entry for each symbolic link encountered
   * while resolving the path.
   * </pre>
   *
   * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
   */
  @java.lang.Override
  public int getSymlinksCount() {
    return symlinks_.size();
  }
  /**
   * <pre>
   * This field is repeated, with one entry for each symbolic link encountered
   * while resolving the path.
   * </pre>
   *
   * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
   */
  @java.lang.Override
  public com.google.devtools.build.lib.skyframe.serialization.proto.Symlink getSymlinks(int index) {
    return symlinks_.get(index);
  }
  /**
   * <pre>
   * This field is repeated, with one entry for each symbolic link encountered
   * while resolving the path.
   * </pre>
   *
   * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
   */
  @java.lang.Override
  public com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder getSymlinksOrBuilder(
      int index) {
    return symlinks_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (((bitField0_ & 0x00000001) != 0)) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, overflowKey_);
    }
    if (((bitField0_ & 0x00000002) != 0)) {
      output.writeInt64(2, parentMtsv_);
    }
    for (int i = 0; i < symlinks_.size(); i++) {
      output.writeMessage(3, symlinks_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (((bitField0_ & 0x00000001) != 0)) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, overflowKey_);
    }
    if (((bitField0_ & 0x00000002) != 0)) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt64Size(2, parentMtsv_);
    }
    for (int i = 0; i < symlinks_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, symlinks_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData)) {
      return super.equals(obj);
    }
    com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData other = (com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData) obj;

    if (hasOverflowKey() != other.hasOverflowKey()) return false;
    if (hasOverflowKey()) {
      if (!getOverflowKey()
          .equals(other.getOverflowKey())) return false;
    }
    if (hasParentMtsv() != other.hasParentMtsv()) return false;
    if (hasParentMtsv()) {
      if (getParentMtsv()
          != other.getParentMtsv()) return false;
    }
    if (!getSymlinksList()
        .equals(other.getSymlinksList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasOverflowKey()) {
      hash = (37 * hash) + OVERFLOW_KEY_FIELD_NUMBER;
      hash = (53 * hash) + getOverflowKey().hashCode();
    }
    if (hasParentMtsv()) {
      hash = (37 * hash) + PARENT_MTSV_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getParentMtsv());
    }
    if (getSymlinksCount() > 0) {
      hash = (37 * hash) + SYMLINKS_FIELD_NUMBER;
      hash = (53 * hash) + getSymlinksList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }

  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * This message contains sufficient information to invalidate Bazel file
   * dependencies against repository diffs.
   *
   * The goal is for this data to represent
   * `com.google.devtools.build.lib.vfs.FileStateKey.argument` values. However,
   * these values are represented within a structure defined by the
   * `com.google.devtools.build.lib.skyframe.FileFunction`, meaning that whenever
   * a `FileStateKey.argument` is encountered, it implies that its parent
   * directory will be present. Therefore, there's going to be significant
   * redundancy in the path information.
   *
   * This redundancy can be exploited for compactness, resulting in this implicit
   * representation.
   *
   * This value is always used in the context of a key-value store (e.g.
   * Memcached), where the key is defined as follows. Let E be some
   * Memcached-friendly encoding function, (e.g. Base64) and `:` be a delimiter in
   * the following (`:` does not occur in Base64, making it a good delimiter). Let
   * MTSV be the maximum transitive source version, a version number that is the
   * maximum version over all the transitive source files affecting an entry. In
   * the case of a file, this includes all source versions of all parent
   * directories and any symlinks needed to resolve it. The MTSV is a canonical
   * version for the file.
   *
   * KEY = E(MTSV) : &lt;FileValue.Key.argument path&gt;
   *
   * Logically, the key consists of the FileValue's MTSV and unresolved path.
   * Note, in particular, the path data present in the key does not need to be
   * repeated in the value. The parent directory of this key is already the
   * `FileValue.Key.argument` path of its parent directory, so that doesn't need
   * to be repeated either. The only additional data needed to identify the
   * `FileInvalidationData` of its parent is the parent's MTSV, which is included
   * as `parent_mtsv`.
   *
   * In the common case, `FileInvalidationData` is empty and that's sufficient
   * information to derive all the paths, assuming that the parent lookups are
   * transitively performed. The `FileStateKey.argument` matches the path present
   * in the key.
   *
   * In the presence of symlinks, special logic applies to produce the resolved
   * paths. A `symlinks` entry will be present. To unpack the symlink entry, we
   * first resolve the parent path as usual. Then, we concatenate the symlink's
   * contents to the resolved parent path and syntactically normalize it
   * (interpreting things like `..`, `.` using string manipulation). This
   * establishes a new path to be recursively resolved. `Symlink` contains another
   * `parent_mtsv` for this purpose. The resulting resolved path is another
   * implicit `FileStateKey.argument` value. If this path is itself a symlink, the
   * process is repeated.
   *
   * Note that this is only suitable for persisting information about a successful
   * build so it ignores symlink cycles.
   * </pre>
   *
   * Protobuf type {@code devtools.skyframe.FileInvalidationData}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:devtools.skyframe.FileInvalidationData)
      com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOuterClass.internal_static_devtools_skyframe_FileInvalidationData_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOuterClass.internal_static_devtools_skyframe_FileInvalidationData_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.class, com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.Builder.class);
    }

    // Construct using com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      overflowKey_ = "";
      parentMtsv_ = 0L;
      if (symlinksBuilder_ == null) {
        symlinks_ = java.util.Collections.emptyList();
      } else {
        symlinks_ = null;
        symlinksBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000004);
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationDataOuterClass.internal_static_devtools_skyframe_FileInvalidationData_descriptor;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData getDefaultInstanceForType() {
      return com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.getDefaultInstance();
    }

    @java.lang.Override
    public com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData build() {
      com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData buildPartial() {
      com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData result = new com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData result) {
      if (symlinksBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0)) {
          symlinks_ = java.util.Collections.unmodifiableList(symlinks_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.symlinks_ = symlinks_;
      } else {
        result.symlinks_ = symlinksBuilder_.build();
      }
    }

    private void buildPartial0(com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData result) {
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.overflowKey_ = overflowKey_;
        to_bitField0_ |= 0x00000001;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.parentMtsv_ = parentMtsv_;
        to_bitField0_ |= 0x00000002;
      }
      result.bitField0_ |= to_bitField0_;
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData) {
        return mergeFrom((com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData other) {
      if (other == com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData.getDefaultInstance()) return this;
      if (other.hasOverflowKey()) {
        overflowKey_ = other.overflowKey_;
        bitField0_ |= 0x00000001;
        onChanged();
      }
      if (other.hasParentMtsv()) {
        setParentMtsv(other.getParentMtsv());
      }
      if (symlinksBuilder_ == null) {
        if (!other.symlinks_.isEmpty()) {
          if (symlinks_.isEmpty()) {
            symlinks_ = other.symlinks_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureSymlinksIsMutable();
            symlinks_.addAll(other.symlinks_);
          }
          onChanged();
        }
      } else {
        if (!other.symlinks_.isEmpty()) {
          if (symlinksBuilder_.isEmpty()) {
            symlinksBuilder_.dispose();
            symlinksBuilder_ = null;
            symlinks_ = other.symlinks_;
            bitField0_ = (bitField0_ & ~0x00000004);
            symlinksBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getSymlinksFieldBuilder() : null;
          } else {
            symlinksBuilder_.addAllMessages(other.symlinks_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              overflowKey_ = input.readStringRequireUtf8();
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 16: {
              parentMtsv_ = input.readInt64();
              bitField0_ |= 0x00000002;
              break;
            } // case 16
            case 26: {
              com.google.devtools.build.lib.skyframe.serialization.proto.Symlink m =
                  input.readMessage(
                      com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.parser(),
                      extensionRegistry);
              if (symlinksBuilder_ == null) {
                ensureSymlinksIsMutable();
                symlinks_.add(m);
              } else {
                symlinksBuilder_.addMessage(m);
              }
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.lang.Object overflowKey_ = "";
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @return Whether the overflowKey field is set.
     */
    public boolean hasOverflowKey() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @return The overflowKey.
     */
    public java.lang.String getOverflowKey() {
      java.lang.Object ref = overflowKey_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        overflowKey_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @return The bytes for overflowKey.
     */
    public com.google.protobuf.ByteString
        getOverflowKeyBytes() {
      java.lang.Object ref = overflowKey_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        overflowKey_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @param value The overflowKey to set.
     * @return This builder for chaining.
     */
    public Builder setOverflowKey(
        java.lang.String value) {
      if (value == null) { throw new NullPointerException(); }
      overflowKey_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @return This builder for chaining.
     */
    public Builder clearOverflowKey() {
      overflowKey_ = getDefaultInstance().getOverflowKey();
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The following field is populated when the key needs to be abbreviated to
     * its fingerprint due to Memcached's key length restriction. This field can
     * be used to verify that no fingerprint collision has occurred.
     * </pre>
     *
     * <code>string overflow_key = 1;</code>
     * @param value The bytes for overflowKey to set.
     * @return This builder for chaining.
     */
    public Builder setOverflowKeyBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) { throw new NullPointerException(); }
      checkByteStringIsUtf8(value);
      overflowKey_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }

    private long parentMtsv_ ;
    /**
     * <pre>
     * The MTSV used to resolve the parent directory.
     *
     * Resolution means creating a key from this MTSV and the parent directory of
     * the key of this entry, looking up the value and interpreting it.
     *
     * Optional. Unset in the following two cases.
     * 1. When the path has no parent, i.e. contains no '/' separators
     * 2. It is a directory and has the common sentinel value, -1.
     * </pre>
     *
     * <code>int64 parent_mtsv = 2;</code>
     * @return Whether the parentMtsv field is set.
     */
    @java.lang.Override
    public boolean hasParentMtsv() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * The MTSV used to resolve the parent directory.
     *
     * Resolution means creating a key from this MTSV and the parent directory of
     * the key of this entry, looking up the value and interpreting it.
     *
     * Optional. Unset in the following two cases.
     * 1. When the path has no parent, i.e. contains no '/' separators
     * 2. It is a directory and has the common sentinel value, -1.
     * </pre>
     *
     * <code>int64 parent_mtsv = 2;</code>
     * @return The parentMtsv.
     */
    @java.lang.Override
    public long getParentMtsv() {
      return parentMtsv_;
    }
    /**
     * <pre>
     * The MTSV used to resolve the parent directory.
     *
     * Resolution means creating a key from this MTSV and the parent directory of
     * the key of this entry, looking up the value and interpreting it.
     *
     * Optional. Unset in the following two cases.
     * 1. When the path has no parent, i.e. contains no '/' separators
     * 2. It is a directory and has the common sentinel value, -1.
     * </pre>
     *
     * <code>int64 parent_mtsv = 2;</code>
     * @param value The parentMtsv to set.
     * @return This builder for chaining.
     */
    public Builder setParentMtsv(long value) {

      parentMtsv_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The MTSV used to resolve the parent directory.
     *
     * Resolution means creating a key from this MTSV and the parent directory of
     * the key of this entry, looking up the value and interpreting it.
     *
     * Optional. Unset in the following two cases.
     * 1. When the path has no parent, i.e. contains no '/' separators
     * 2. It is a directory and has the common sentinel value, -1.
     * </pre>
     *
     * <code>int64 parent_mtsv = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearParentMtsv() {
      bitField0_ = (bitField0_ & ~0x00000002);
      parentMtsv_ = 0L;
      onChanged();
      return this;
    }

    private java.util.List<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink> symlinks_ =
      java.util.Collections.emptyList();
    private void ensureSymlinksIsMutable() {
      if (!((bitField0_ & 0x00000004) != 0)) {
        symlinks_ = new java.util.ArrayList<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink>(symlinks_);
        bitField0_ |= 0x00000004;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.google.devtools.build.lib.skyframe.serialization.proto.Symlink, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder, com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder> symlinksBuilder_;

    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public java.util.List<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink> getSymlinksList() {
      if (symlinksBuilder_ == null) {
        return java.util.Collections.unmodifiableList(symlinks_);
      } else {
        return symlinksBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public int getSymlinksCount() {
      if (symlinksBuilder_ == null) {
        return symlinks_.size();
      } else {
        return symlinksBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public com.google.devtools.build.lib.skyframe.serialization.proto.Symlink getSymlinks(int index) {
      if (symlinksBuilder_ == null) {
        return symlinks_.get(index);
      } else {
        return symlinksBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder setSymlinks(
        int index, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink value) {
      if (symlinksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSymlinksIsMutable();
        symlinks_.set(index, value);
        onChanged();
      } else {
        symlinksBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder setSymlinks(
        int index, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder builderForValue) {
      if (symlinksBuilder_ == null) {
        ensureSymlinksIsMutable();
        symlinks_.set(index, builderForValue.build());
        onChanged();
      } else {
        symlinksBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder addSymlinks(com.google.devtools.build.lib.skyframe.serialization.proto.Symlink value) {
      if (symlinksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSymlinksIsMutable();
        symlinks_.add(value);
        onChanged();
      } else {
        symlinksBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder addSymlinks(
        int index, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink value) {
      if (symlinksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSymlinksIsMutable();
        symlinks_.add(index, value);
        onChanged();
      } else {
        symlinksBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder addSymlinks(
        com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder builderForValue) {
      if (symlinksBuilder_ == null) {
        ensureSymlinksIsMutable();
        symlinks_.add(builderForValue.build());
        onChanged();
      } else {
        symlinksBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder addSymlinks(
        int index, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder builderForValue) {
      if (symlinksBuilder_ == null) {
        ensureSymlinksIsMutable();
        symlinks_.add(index, builderForValue.build());
        onChanged();
      } else {
        symlinksBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder addAllSymlinks(
        java.lang.Iterable<? extends com.google.devtools.build.lib.skyframe.serialization.proto.Symlink> values) {
      if (symlinksBuilder_ == null) {
        ensureSymlinksIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, symlinks_);
        onChanged();
      } else {
        symlinksBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder clearSymlinks() {
      if (symlinksBuilder_ == null) {
        symlinks_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        symlinksBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public Builder removeSymlinks(int index) {
      if (symlinksBuilder_ == null) {
        ensureSymlinksIsMutable();
        symlinks_.remove(index);
        onChanged();
      } else {
        symlinksBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder getSymlinksBuilder(
        int index) {
      return getSymlinksFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder getSymlinksOrBuilder(
        int index) {
      if (symlinksBuilder_ == null) {
        return symlinks_.get(index);  } else {
        return symlinksBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public java.util.List<? extends com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder> 
         getSymlinksOrBuilderList() {
      if (symlinksBuilder_ != null) {
        return symlinksBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(symlinks_);
      }
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder addSymlinksBuilder() {
      return getSymlinksFieldBuilder().addBuilder(
          com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.getDefaultInstance());
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder addSymlinksBuilder(
        int index) {
      return getSymlinksFieldBuilder().addBuilder(
          index, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.getDefaultInstance());
    }
    /**
     * <pre>
     * This field is repeated, with one entry for each symbolic link encountered
     * while resolving the path.
     * </pre>
     *
     * <code>repeated .devtools.skyframe.Symlink symlinks = 3;</code>
     */
    public java.util.List<com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder> 
         getSymlinksBuilderList() {
      return getSymlinksFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.google.devtools.build.lib.skyframe.serialization.proto.Symlink, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder, com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder> 
        getSymlinksFieldBuilder() {
      if (symlinksBuilder_ == null) {
        symlinksBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.google.devtools.build.lib.skyframe.serialization.proto.Symlink, com.google.devtools.build.lib.skyframe.serialization.proto.Symlink.Builder, com.google.devtools.build.lib.skyframe.serialization.proto.SymlinkOrBuilder>(
                symlinks_,
                ((bitField0_ & 0x00000004) != 0),
                getParentForChildren(),
                isClean());
        symlinks_ = null;
      }
      return symlinksBuilder_;
    }

    // @@protoc_insertion_point(builder_scope:devtools.skyframe.FileInvalidationData)
  }

  // @@protoc_insertion_point(class_scope:devtools.skyframe.FileInvalidationData)
  private static final com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData();
  }

  public static com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FileInvalidationData>
      PARSER = new com.google.protobuf.AbstractParser<FileInvalidationData>() {
    @java.lang.Override
    public FileInvalidationData parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<FileInvalidationData> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FileInvalidationData> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.devtools.build.lib.skyframe.serialization.proto.FileInvalidationData getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

